Subject: Re: Two Different Routes to the Same Node, One with Via

From: John Goerzen <[email-masked]>
Date: Sun, 12 Dec 2021 14:52:54 -0600

On Sun, Dec 12 2021, Sergey Matveev wrote:

> Currently I assume that multicast can be used in the case you described.
> I did not check it and can not tell is it stupid idea, but I believe
> that you can create multicast area and subscribe Foo, Bar, Baz on it.
> Then you send file/exec/whatever to that area. When you are on LAN, then
> both Bar and Baz receives it. After a while Bar will receive the same
> multicasted packet from Baz, but will delete it, because it was already
> seen after processing the packet got directly from Foo. When you are on
> WAN, then packet to Bar is queued, but packet to Baz is sent (and Bar
> receives it). When you are back at LAN, then you send previously queued
> packet to Bar, that is deleted on it, because it was seen from the Baz.
> Of course that doubles the real amount of traffic and disk consumption
> on some nodes, so hardly it is helpful :-), but it can deliver packets
> directly to Bar faster.

This is a really interesting point; as I was reading this, I was
thinking "the packet could be encrypted to both the destination and the
relay when it's created" but multicast can effectively achieve this
also.

Actually all that is needed to support Koushik's scenario perfectly
would be a "max delivery" setting.  Set it to 1, and after NNCP delivers
a multicast packet to one destination, it would stop efforts to deliver
it to any more.

I also have the same use case Koushik identified and this would be
perfect there.

- John